DifferentSelector (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.types.selectors, class: DifferentSelector

# Class DifferentSelector

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.types.DataType
org.apache.tools.ant.types.selectors.BaseSelector
org.apache.tools.ant.types.selectors.MappingSelector
org.apache.tools.ant.types.selectors.DifferentSelector

All Implemented Interfaces:
  `Cloneable, ResourceSelector, FileSelector`

public class DifferentSelector extends MappingSelector
This selector selects files against a mapped set of target files, selecting all those files which are different. Files with different lengths are deemed different automatically Files with identical timestamps are viewed as matching by default, unless you specify otherwise. Contents are compared if the lengths are the same and the timestamps are ignored or the same, except if you decide to ignore contents to gain speed.

This is a useful selector to work with programs and tasks that don't handle dependency checking properly; Even if a predecessor task always creates its output files, followup tasks can be driven off copies made with a different selector, so their dependencies are driven on the absolute state of the files, not a timestamp.

Clearly, however, bulk file comparisons is inefficient; anything that can use timestamps is to be preferred. If this selector must be used, use it over as few files as possible, perhaps following it with an <uptodate> to keep the descendant routines conditional.

- ## Field Summary

  ### Fields inherited from class MappingSelector

  `granularity, map, mapperElement, targetdir`
  Modifier and Type
  Field
  Description
  `protected int`
  `granularity`
  `protected FileNameMapper`
  `map`
  `protected Mapper`
  `mapperElement`
  `protected File`
  `targetdir`

  ### Fields inherited from class DataType

  `checked, ref`
  Modifier and Type
  Field
  Description
  `protected boolean`
  `checked`
  Deprecated.
  since 1.7.
  `protected Reference`
  `ref`
  Deprecated.
  since 1.7.

  ### Fields inherited from class ProjectComponent

  `description, location, project`
  Modifier and Type
  Field
  Description
  `protected String`
  `description`
  Deprecated.
  since 1.6.x.
  `protected Location`
  `location`
  Deprecated.
  since 1.6.x.
  `protected Project`
  `project`
  Deprecated.
  since 1.6.x.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DifferentSelector()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected boolean`
  `selectionTest(File srcfile, File destfile)`
  this test is our selection test that compared the file with the destfile
  `void`
  `setIgnoreContents(boolean ignoreContents)`
  This flag tells the selector to ignore contents
  `void`
  `setIgnoreFileTimes(boolean ignoreFileTimes)`
  This flag tells the selector to ignore file times in the comparison

  ### Methods inherited from class MappingSelector

  `addConfigured, createMapper, isSelected, setGranularity, setTargetdir, verifySettings`
  Modifier and Type
  Method
  Description
  `void`
  `addConfigured(FileNameMapper fileNameMapper)`
  Add a configured FileNameMapper instance.
  `Mapper`
  `createMapper()`
  Defines the FileNameMapper to use (nested mapper element).
  `boolean`
  `isSelected(File basedir, String filename, File file)`
  The heart of the matter.
  `void`
  `setGranularity(int granularity)`
  Sets the number of milliseconds leeway we will give before we consider a file out of date.
  `void`
  `setTargetdir(File targetdir)`
  The name of the file or directory which is checked for out-of-date files.
  `void`
  `verifySettings()`
  Checks to make sure all settings are kosher.

  ### Methods inherited from class BaseSelector

  `getError, setError, setError, validate`
  Modifier and Type
  Method
  Description
  `String`
  `getError()`
  Returns any error messages that have been set.
  `void`
  `setError(String msg)`
  Allows all selectors to indicate a setup error.
  `void`
  `setError(String msg, Throwable cause)`
  Allows all selectors to indicate a setup error.
  `void`
  `validate()`
  Subclasses can use this to throw the requisite exception in isSelected() in the case of an error condition.

  ### Methods inherited from class DataType

  `checkAttributesAllowed, checkChildrenAllowed, circularReference, clone, dieOnCircularReference, dieOnCircularReference, dieOnCircularReference, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getDataTypeName, getRefid, invokeCircularReferenceCheck, isChecked, isReference, noChildrenAllowed, pushAndInvokeCircularReferenceCheck, setChecked, setRefid, tooManyAttributes, toString`
  Modifier and Type
  Method
  Description
  `protected void`
  `checkAttributesAllowed()`
  check that it is ok to set attributes, i.e that no reference is defined
  `protected void`
  `checkChildrenAllowed()`
  check that it is ok to add children, i.e that no reference is defined
  `protected BuildException`
  `circularReference()`
  Creates an exception that indicates the user has generated a loop of data types referencing each other.
  `Object`
  `clone()`
  `protected void`
  `dieOnCircularReference()`
  Convenience method.
  `protected void`
  `dieOnCircularReference(Stack<Object> stack, Project project)`
  Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).
  `protected void`
  `dieOnCircularReference(Project p)`
  Convenience method.
  `protected <T> T`
  `getCheckedRef()`
  Deprecated.
  use getCheckedRef(Class)
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName, Project project)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Project p)`
  Deprecated.
  use getCheckedRef(Class)
  `protected String`
  `getDataTypeName()`
  Gets as descriptive as possible a name used for this datatype instance.
  `Reference`
  `getRefid()`
  get the reference set on this object
  `static void`
  `invokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected boolean`
  `isChecked()`
  The flag that is used to indicate that circular references have been checked.
  `boolean`
  `isReference()`
  Has the refid attribute of this element been set?
  `protected BuildException`
  `noChildrenAllowed()`
  Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.
  `static void`
  `pushAndInvokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected void`
  `setChecked(boolean checked)`
  Set the flag that is used to indicate that circular references have been checked.
  `void`
  `setRefid(Reference ref)`
  Set the value of the refid attribute.
  `protected BuildException`
  `tooManyAttributes()`
  Creates an exception that indicates that refid has to be the only attribute if it is set.
  `String`
  `toString()`
  Basic DataType toString().

  ### Methods inherited from class ProjectComponent

  `getDescription, getLocation, getProject, log, log, setDescription, setLocation, setProject`
  Modifier and Type
  Method
  Description
  `String`
  `getDescription()`
  Returns the description of the current action.
  `Location`
  `getLocation()`
  Returns the file/location where this task was defined.
  `Project`
  `getProject()`
  Returns the project to which this component belongs.
  `void`
  `log(String msg)`
  Logs a message with the default (INFO) priority.
  `void`
  `log(String msg, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `setDescription(String desc)`
  Sets a description of the current action.
  `void`
  `setLocation(Location location)`
  Sets the file/location where this task was defined.
  `void`
  `setProject(Project project)`
  Sets the project object of this component.

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface FileSelector

  `isSelected`
  Modifier and Type
  Method
  Description
  `default boolean`
  `isSelected(Resource r)`
  Implement a basic `Resource` selection that delegates to this `FileSelector`.

- ## Constructor Details

  - ### DifferentSelector

    public DifferentSelector()

- ## Method Details

  - ### setIgnoreFileTimes

    public void setIgnoreFileTimes(boolean ignoreFileTimes)
    This flag tells the selector to ignore file times in the comparison
    Parameters:
      `ignoreFileTimes` - if true ignore file times

  - ### setIgnoreContents

    public void setIgnoreContents(boolean ignoreContents)
    This flag tells the selector to ignore contents
    Parameters:
      `ignoreContents` - if true ignore contents
    Since:
      ant 1.6.3

  - ### selectionTest

    protected boolean selectionTest(File srcfile, File destfile)
    this test is our selection test that compared the file with the destfile
    Specified by:
      `selectionTest` in class `MappingSelector`
    Parameters:
      `srcfile` - the source file
      `destfile` - the destination file
    Returns:
      true if the files are different